module CNT16(RST,CLK,Q);

parameter wordsize=16;

    input                   RST;
    input                   CLK;
    output  [wordsize-1:0]  Q;

    reg     [wordsize-1:0]  counter;
    wire    [wordsize:0]    counter_inc;
    wire    [wordsize-1:0]  Q;

    always@(negedge RST or posedge CLK) begin
        if (!RST)
            counter <= 0;
        else
            counter <= counter_inc[wordsize-1:0];
    end

    assign counter_inc = (counter + 1);

	assign Q = counter;

endmodule
